    ;###########################################################################
    ; MIDI o API ֘AW[  midiapi  for HSP 3.0
    ;###########################################################################

    ;---------------------------------------------------------------------------
    ; GetMidiDevNum
    ;
    ; MIDI o̓foCX̐擾܂BMIDI Mapper ͐Ɋ܂݂܂B
    ;
    ; s stat ̒l
    ;  stat :  MIDI o̓foCX̐
    ;

    ;---------------------------------------------------------------------------
    ; GetMidiDevName  id
    ;     id : O擾 MIDI o̓foCX ID
    ;
    ; o̓foCX̖O擾܂B
    ;
    ; s stat, refstr ̒l
    ;  stat=0 : Ɏ擾
    ;       1 : 擾̃G[
    ;  refstr : 擾foCX
    ;

    ;---------------------------------------------------------------------------
    ; MidiOpen  id
    ;     id : MIDI o̓foCX ID (MIDI mapper  id = -1)
    ;
    ; MIDI o̓foCXJ܂BȌÃfoCXɃbZ[W𑗂܂B
    ;
    ; s stat ̒l
    ;  stat=0 : Ɏs܂B
    ;       1 : MIDI |[g܂B(MIDI mapper w莞̂)
    ;       2 : w肳ă\[X͂łɊ蓖ĂĂ܂B
    ;       3 : w肳ꂽfoCX ID ͔͈͊OłB
    ;       4 ȏ : ̑̃G[
    ;

    ;---------------------------------------------------------------------------
    ; MidiClose
    ;
    ; MIDI o̓foCX܂B
    ;
    ; s stat ̒l
    ;  stat =  0  : Ɏs܂B
    ;          1  : ܂L[Ƀobt@cĂ܂B
    ;          2  : w肳ꂽfoCXnh͖łB
    ;          3 ȏ : ̑̃G[
    ;

    ;---------------------------------------------------------------------------
    ; SendMidiMsg  st, b1, b2
    ;    st : Xe[^XoCg
    ;    b1 : PoCg
    ;    b2 : QoCg
    ;
    ; SendMidiMsg2  data
    ;    data : M郁bZ[W
    ;
    ; MIDI o̓foCXɒZ MIDI bZ[W𑗐M܂B
    ;

    ;---------------------------------------------------------------------------
    ; SendMidiLongMsg data, flag
    ;    data : M郁bZ[Wi[obt@
    ;    size : bZ[W̃TCY
    ;
    ; MIDI o̓foCXɒ MIDI bZ[W𑗐M܂B
    ;

    ;---------------------------------------------------------------------------
    ; MidiReset
    ;
    ; MIDI foCXׂ̂Ă MIDI `l̔~AL[ɎcĂ
    ; obt@NA܂B


    ;---------------------------------------------------------------------------
    ; m[gI
    ; midiNoteOn  p1, p2, p3
    ;    p1 : `lio[ (0`15)
    ;    p2 : m[gio[ (0`127)
    ;    p3 : m[gIxVeB[(0`127)
    ;---------------------------------------------------------------------------
    ; m[gIt
    ; midiNoteOff  p1, p2
    ;    p1 : `lio[ (0`15)
    ;    p2 : m[gio[ (0`127)
    ;---------------------------------------------------------------------------
    ; {[
    ; midiVolume  p1, p2
    ;    p1 : `lio[ (0`15)
    ;    p2 : {[ (0`127)(l:100)
    ;---------------------------------------------------------------------------
    ; p|bg
    ; midiPanpot  p1, p2
    ;    p1 : `lio[ (0`15)
    ;    p2 : p|bg (0`127)(l:64)
    ;---------------------------------------------------------------------------
    ; GNXvbV
    ; midiExpression  p1, p2
    ;    p1 : `lio[ (0`15)
    ;    p2 : GNXvbV (0`127)(l:127)
    ;---------------------------------------------------------------------------
    ; z[h
    ; midiHold  p1, p2
    ;    p1 : `lio[ (0`15)
    ;    p2 = 0 : z[h OFF
    ;         1 : z[h ON
    ;---------------------------------------------------------------------------
    ; o[uZhx
    ; midiReverb  p1, p2
    ;    p1 : `lio[ (0`15)
    ;    p2 : o[uZhx (0`127)(l:40)
    ;---------------------------------------------------------------------------
    ; R[XZhx
    ; midiChorus  p1, p2
    ;    p1 : `lio[ (0`15)
    ;    p2 : R[XZhx (0`127)(l:0)
    ;---------------------------------------------------------------------------
    ; vO`FW
    ; midiProgram  p1, p2
    ;    p1 : `lio[ (0`15)
    ;    p2 : vOio[ (0`127)
    ;---------------------------------------------------------------------------
    ; sb`xh`FW
    ; midiPitchBend  p1, p2
    ;    p1 : `lio[ (0`15)
    ;    p2 : sb`xhl (-8192 ` 8191)
    ;---------------------------------------------------------------------------
    ; I[TEhIt
    ; midiAllSoundOff  p1
    ;    p1 : `lio[ (0`15)
    ;---------------------------------------------------------------------------
    ; ZbgI[Rg[[
    ; midiResetAllControl  p1
    ;    p1 : `lio[ (0`15)
    ;---------------------------------------------------------------------------
    ; I[m[gIt
    ; midiAllNoteOff  p1
    ;    p1 : `lio[ (0`15)
    ;---------------------------------------------------------------------------
    ; GM1 VXeI
    ; midiGmSystemOn
    ;---------------------------------------------------------------------------
    ; GM2 VXeI
    ; midiGm2SystemOn
    ;---------------------------------------------------------------------------

    #ifndef __MIDIAPI__
    #define global __MIDIAPI__

    #module midiapi

    ; MIDIOUTCAPS \ wTechnology õtO
    #define MOD_MIDIPORT    1
    #define MOD_SYNTH       2
    #define MOD_SQSYNTH     3
    #define MOD_FMSYNTH     4
    #define MOD_MAPPER      5

    ; MIDIOUTCAPS \ dwSupport õtO
    #define MIDICAPS_VOLUME      0x0001
    #define MIDICAPS_LRVOLUME    0x0002
    #define MIDICAPS_CACHE       0x0004
    #define MIDICAPS_STREAM      0x0008

    ; G[̖߂l
    #define MMSYSERR_NOERROR      0
    #define MMSYSERR_ALLOCATED    4
    #define MMSYSERR_BADDEVICEID  2
    #define MMSYSERR_INVALPARAM   11
    #define MMSYSERR_NOMEM        7
    #define MMSYSERR_INVALHANDLE  5
    #define MIDIERR_NODEVICE      68
    #define MIDIERR_STILLPLAYING  65

    ; API
    #uselib "kernel32.dll"
    #func Sleep "Sleep" int

    #uselib "winmm.dll"
    #func midiOutGetNumDevs      "midiOutGetNumDevs"
    #func midiOutGetDevCaps      "midiOutGetDevCapsA"     int,int,int
    #func midiOutOpen            "midiOutOpen"            int,int,int,int,int
    #func midiOutClose           "midiOutClose"           int
    #func midiOutReset           "midiOutReset"           int
    #func midiOutShortMsg        "midiOutShortMsg"        int,int
    #func midiOutLongMsg         "midiOutLongMsg"         int,int,int
    #func midiOutPrepareHeader   "midiOutPrepareHeader"   int,int,int
    #func midiOutUnprepareHeader "midiOutUnprepareHeader" int,int,int


    ;---------------------------------------------------------------------------
    ; _midi_prep (Op̖)
    ;---------------------------------------------------------------------------
    #deffunc _midi_prep

    hMidiOut = 0        ; MIDI o̓foCX̃nh邽߂̕ϐ
    ; wDeviceID = 0     ; MIDI o̓foCX ID 邽߂̕ϐ

    ; ObZ[Wpobt@
    dim midihdr, 16

    ; MIDIOUTCAPS \
    dim outcaps, 16
    return

    ;---------------------------------------------------------------------------
    ; GetMidiDevNum
    ;---------------------------------------------------------------------------
    #deffunc GetMidiDevNum
    midiOutGetNumDevs
    return

    ;---------------------------------------------------------------------------
    ; GetMidiDevName
    ;---------------------------------------------------------------------------
    #deffunc GetMidiDevName int idx
    mref rfst, 65
    midiOutGetDevCaps idx, varptr(outcaps), 52
    if stat : rfst = "" : return 1
    getstr rfst, outcaps, 8
    return 0

    ;---------------------------------------------------------------------------
    ; MidiClose
    ;---------------------------------------------------------------------------
    #deffunc MidiClose
    midiOutClose hMidiOut
    if (stat == MMSYSERR_NOERROR) {
        hMidiOut = 0
        return 0
    } else if (stat == MIDIERR_STILLPLAYING) {
        return 1
    } else if (stat == MMSYSERR_INVALHANDLE) {
        return 2
    } else if (stat == MMSYSERR_NOMEMI) {
        return 3
    }
    return 4

    ;---------------------------------------------------------------------------
    ; MidiOpen
    ;---------------------------------------------------------------------------
    #deffunc MidiOpen int devid
    if hMidiOut : gosub MidiClose

    midiOutOpen varptr(hMidiOut), devid, 0, 0, 0
    if (stat == MMSYSERR_NOERROR) {
        return 0
    } else if (stat == MIDIERR_NODEVICE) {
        return 1
    } else if (stat == MMSYSERR_ALLOCATED) {
        return 2
    } else if (stat == MMSYSERR_BADDEVICEID) {
        return 3
    } else if (stat == MMSYSERR_INVALPARAM) {
        return 4
    } else if (stat == MMSYSERR_NOMEM) {
        return 5
    }
    return 6

    ;---------------------------------------------------------------------------
    ; SendMidiMsg
    ;---------------------------------------------------------------------------
    #deffunc SendMidiMsg int p1, int p2, int p3
    midiOutShortMsg hMidiOut, (p1&$FF)|((p2&$FF)<<8)|((p3&$FF)<<16)
    return

    ;---------------------------------------------------------------------------
    ; SendMidiMsg2
    ;---------------------------------------------------------------------------
    #deffunc SendMidiMsg2 int p1
    midiOutShortMsg hMidiOut, p1
    return

    ;---------------------------------------------------------------------------
    ; SendMidiLongMsg
    ;---------------------------------------------------------------------------
    #deffunc SendMidiLongMsg var data, int len
    midihdr = varptr(data), len
    midiOutPrepareHeader hMidiOut, varptr(midihdr), 48
    midiOutLongMsg hMidiOut, varptr(midihdr), 48
    ; |[O(midiHdr.dwFrag  MHDR_DONE (=1) Zbg܂)
    ; (R[obNɂ邩H)
    repeat 1000
        if midihdr.4 & 1 : break
        Sleep 0
    loop
    ; n
    midiOutUnprepareHeader hMidiOut, varptr(midihdr), 48
    return

    ;---------------------------------------------------------------------------
    ; MidiReset
    ;---------------------------------------------------------------------------
    #deffunc MidiReset
    midiOutReset hMidiOut
    return

    #global ;-------------------------------------------------------------------


    #module midimsg

    #deffunc midiNoteOn int b0, int b1, int b2
    SendMidiMsg $90|b0, b1, b2
    return

    #deffunc midiNoteOff int b0, int b1
    SendMidiMsg $90|b0, b1
    return

    #deffunc midiVolume int b0, int b1
    SendMidiMsg $B0|b0, $07, b1
    return

    #deffunc midiPanpot int b0, int b1
    SendMidiMsg $B0|b0, $0A, b1
    return

    #deffunc midiExpression int b0, int b1
    SendMidiMsg $B0|b0, $0B, b1
    return

    #deffunc midiHold int b0, int b1
    if b1 {
        SendMidiMsg $B0|b0, $40, $7F
    } else {
        SendMidiMsg $B0|b0, $40, 0
    }
    return

    #deffunc midiReverb int b0, int b1
    SendMidiMsg $B0|b0, $5B, b1
    return

    #deffunc midiChorus int b0, int b1
    SendMidiMsg $B0|b0, $5D, b1
    return

    #deffunc midiProgram int b0, int b1
    SendMidiMsg $C0|b0, b1
    return

    #deffunc midiPitchBend int b0, int b1
    data = b1 + 8192
    SendMidiMsg $E0|b0, data&$7F, data>>7
    return

    #deffunc midiAllSoundOff int b0
    SendMidiMsg $B0|b0, $78, 0
    return

    #deffunc midiResetAllControl int b0
    SendMidiMsg $B0|b0, $79, 0
    return

    #deffunc midiAllNoteOff int b0
    mref byte0
    SendMidiMsg $B0|b0, $7B, 0
    return

    #deffunc midiGmSystemOn
    data = $097F7EF0,$F701      ; $F0,$7E,$7F,$09, $01,$F7
    SendMidiLongMsg data,6
    return

    #deffunc midiGm2SystemOn
    data = $097F7EF0,$F703      ; $F0,$7E,$7F,$09, $03,$F7
    SendMidiLongMsg data,6
    return

    #global ;-------------------------------------------------------------------

    _midi_prep      ; MIDI foCXg

    #endif

    ;###########################################################################
    ;           Copyright (C) 2001-2005 傭. All Rights Reserved.
    ;###########################################################################
